diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/wifi-emlsr-test.cc ns-3.41/src/wifi/test/wifi-emlsr-test.cc
--- ns-3.40/src/wifi/test/wifi-emlsr-test.cc	2023-09-27 13:30:37.922839900 -0700
+++ ns-3.41/src/wifi/test/wifi-emlsr-test.cc	2024-02-09 14:44:08.613795300 -0800
@@ -2284,7 +1857,7 @@
         // both EMLSR clients are about to receive a QoS data frame
         for (std::size_t clientId : {firstClientId, secondClientId})
         {
-            Simulator::Schedule(txDuration, [=]() {
+            Simulator::Schedule(txDuration, [=, this]() {
                 for (uint8_t id = 0; id < m_staMacs[clientId]->GetNLinks(); id++)
                 {
                     // link on which QoS data is received is not blocked
@@ -2329,7 +1902,7 @@
 
         // immediately before the end of the PPDU, this link only is not blocked for the EMLSR
         // client on the AP MLD
-        Simulator::Schedule(txDuration - NanoSeconds(1), [=]() {
+        Simulator::Schedule(txDuration - NanoSeconds(1), [=, this]() {
             for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
             {
                 CheckBlockedLink(m_apMac,
@@ -2345,7 +1918,7 @@
         // immediately before the end of the PPDU, all the links on the EMLSR client that is not
         // the recipient of the second QoS frame are unblocked (they are unblocked when the
         // PHY-RXSTART.indication is not received)
-        Simulator::Schedule(txDuration - NanoSeconds(1), [=]() {
+        Simulator::Schedule(txDuration - NanoSeconds(1), [=, this]() {
             for (uint8_t id = 0; id < m_staMacs[secondClientId]->GetNLinks(); id++)
             {
                 CheckBlockedLink(m_staMacs[secondClientId],
@@ -2359,7 +1932,7 @@
             }
         });
         // immediately after the end of the PPDU, all links are blocked for the EMLSR client
-        Simulator::Schedule(txDuration + NanoSeconds(1), [=]() {
+        Simulator::Schedule(txDuration + NanoSeconds(1), [=, this]() {
             for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
             {
                 CheckBlockedLink(m_apMac,
@@ -2375,7 +1948,7 @@
         // immediately before the transition delay, all links are still blocked for the EMLSR client
         Simulator::Schedule(
             txDuration + m_transitionDelay.at(secondClientId) - NanoSeconds(1),
-            [=]() {
+            [=, this]() {
                 for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
                 {
                     CheckBlockedLink(
@@ -2385,15 +1958,64 @@
                         WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
                         true,
                         "Checking links of EMLSR client " + std::to_string(secondClientId) +
-                            " are all blocked on the AP MLD before the transition delay");
+                            " are all blocked on the AP MLD before the transition delay",
+                        false);
                 }
             });
 
+        // 100 us before the transition delay expires, generate another small packet addressed
+        // to a non-EMLSR client. The AP will start a TXOP to transmit this frame, while the
+        // frame addressed to the EMLSR client is still queued because the transition delay has
+        // not yet elapsed. The transition delay will expire while the AP is transmitting the
+        // frame to the non-EMLSR client, so that the AP continues the TXOP to transmit the frame
+        // to the EMLSR client and we can check that the AP performs PIFS recovery after missing
+        // the BlockAck from the EMLSR client
+        Simulator::Schedule(txDuration + m_transitionDelay.at(secondClientId) - MicroSeconds(100),
+                            [=, this]() {
+                                m_apMac->GetDevice()->GetNode()->AddApplication(
+                                    GetApplication(DOWNLINK, m_nEmlsrStations, 1, 40));
+                            });
+
         break;
     case 3:
-        // at the end of the third QoS frame, this link only is not blocked on the EMLSR
+        // this is the frame addressed to a non-EMLSR client, which is transmitted before the
+        // frame addressed to the EMLSR client, because the links of the latter are still blocked
+        // at the AP because the transition delay has not yet elapsed
+        NS_TEST_EXPECT_MSG_EQ(
+            psduMap.cbegin()->second->GetAddr1(),
+            m_staMacs[m_nEmlsrStations]->GetFrameExchangeManager(linkId)->GetAddress(),
+            "QoS frame not addressed to a non-EMLSR client");
+
+        for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
+        {
+            CheckBlockedLink(m_apMac,
+                             addr,
+                             id,
+                             WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
+                             true,
+                             "Checking links of EMLSR client " + std::to_string(secondClientId) +
+                                 " are all blocked on the AP MLD before the transition delay");
+        }
+        // Block transmissions to the EMLSR client on all the links but the one on which this
+        // frame is sent, so that the AP will continue this TXOP to send the queued frame to the
+        // EMLSR client once the transition delay elapses
+        for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
+        {
+            if (id != linkId)
+            {
+                m_apMac->BlockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED, addr, {id});
+            }
+        }
+        break;
+    case 4:
+        // the AP is continuing the TXOP, no need to block transmissions anymore
+        for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
+        {
+            m_apMac->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED, addr, {id});
+        }
+        // at the end of the fourth QoS frame, this link only is not blocked on the EMLSR
         // client receiving the frame
-        Simulator::Schedule(txDuration, [=]() {
+        Simulator::Schedule(txDuration, [=, this]() {
             for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
             {
                 CheckBlockedLink(m_staMacs[secondClientId],
@@ -2403,7 +2025,7 @@
                                  id != linkId,
                                  "Checking EMLSR links on EMLSR client " +
                                      std::to_string(secondClientId) +
-                                     " after receiving the third QoS data frame");
+                                     " after receiving the fourth QoS data frame");
             }
         });
         break;
@@ -2422,6 +2044,12 @@
         return;
     }
 
+    if (++m_countBlockAck == 4)
+    {
+        // fourth BlockAck is sent by a non-EMLSR client
+        return;
+    }
+
     auto taddr = psduMap.cbegin()->second->GetAddr2();
     std::size_t clientId;
     if (m_staMacs[0]->GetLinkIdByAddress(taddr))
@@ -2452,14 +2080,13 @@
     auto txDuration = WifiPhy::CalculateTxDuration(psduMap, txVector, apPhy->GetPhyBand());
     auto cfEndTxDuration = WifiPhy::CalculateTxDuration(
         Create<WifiPsdu>(Create<Packet>(), WifiMacHeader(WIFI_MAC_CTL_END)),
-        m_apMac->GetWifiRemoteStationManager(linkId)->GetRtsTxVector(Mac48Address::GetBroadcast()),
+        m_apMac->GetWifiRemoteStationManager(linkId)->GetRtsTxVector(Mac48Address::GetBroadcast(),
+                                                                     txVector.GetChannelWidth()),
         apPhy->GetPhyBand());
 
-    m_countBlockAck++;
-
     switch (m_countBlockAck)
     {
-    case 4:
+    case 5:
         // the PPDU carrying this BlockAck is corrupted, hence the AP MLD MAC receives the
         // PHY-RXSTART indication but it does not receive any frame from the PHY. Therefore,
         // at the end of the PPDU transmission, the AP MLD realizes that the EMLSR client has
@@ -2467,7 +2094,7 @@
 
         // at the end of the PPDU, this link only is not blocked on both the EMLSR client and
         // the AP MLD
-        Simulator::Schedule(txDuration, [=]() {
+        Simulator::Schedule(txDuration, [=, this]() {
             for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
             {
                 CheckBlockedLink(m_staMacs[clientId],
@@ -2488,7 +2115,7 @@
         });
         // a SIFS after the end of the PPDU, still this link only is not blocked on both the
         // EMLSR client and the AP MLD
-        Simulator::Schedule(txDuration + apPhy->GetSifs(), [=]() {
+        Simulator::Schedule(txDuration + apPhy->GetSifs(), [=, this]() {
             for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
             {
                 CheckBlockedLink(m_staMacs[clientId],
@@ -2513,10 +2140,10 @@
             m_errorModel->SetList({uid});
         }
         break;
-    case 5:
+    case 6:
         // at the end of the PPDU, this link only is not blocked on both the EMLSR client and
         // the AP MLD
-        Simulator::Schedule(txDuration, [=]() {
+        Simulator::Schedule(txDuration, [=, this]() {
             for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
             {
                 CheckBlockedLink(m_staMacs[clientId],
@@ -2539,7 +2166,7 @@
         // EMLSR client and the AP MLD
         Simulator::Schedule(
             txDuration + apPhy->GetSifs() + cfEndTxDuration - MicroSeconds(1),
-            [=]() {
+            [=, this]() {
                 for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
                 {
                     CheckBlockedLink(m_staMacs[clientId],
@@ -2562,7 +2189,7 @@
         // AP MLD
         Simulator::Schedule(
             txDuration + apPhy->GetSifs() + cfEndTxDuration + MicroSeconds(1),
-            [=]() {
+            [=, this]() {
                 for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
                 {
                     CheckBlockedLink(
@@ -2580,7 +2207,7 @@
         Simulator::Schedule(
             txDuration + apPhy->GetSifs() + cfEndTxDuration + m_transitionDelay.at(clientId) -
                 MicroSeconds(1),
-            [=]() {
+            [=, this]() {
                 for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
                 {
                     CheckBlockedLink(
@@ -2597,7 +2224,7 @@
         Simulator::Schedule(
             txDuration + apPhy->GetSifs() + cfEndTxDuration + m_transitionDelay.at(clientId) +
                 MicroSeconds(1),
-            [=]() {
+            [=, this]() {
                 for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
                 {
                     CheckBlockedLink(
